// Payload Last Point to Control Point
//  by Sarexicus (give credit!)
// ----------------------------------

tf_gamerules <- Entities.FindByClassname(null, "tf_gamerules");
team_train_watcher <- Entities.FindByClassname(null, "team_train_watcher");
obj_res <- Entities.FindByClassname(null, "tf_objective_resource");

control_point_count <- 0;

// ----------------------------------

// make sure everything's initialised before doing the setup
EntFireByHandle(self, "CallScriptFunction", "Setup", 0, null, null);

function Setup() {
    NetProps.SetPropInt(tf_gamerules, "m_nHudType", 3);
    team_train_watcher.AcceptInput("Enable", "", null, null);

    // count control points (including the fake CP)
    control_point_count = 0;
    for (local entity; entity = Entities.FindByClassname(entity, "team_control_point");)
    {
        control_point_count++;
    }

    NetProps.SetPropInt(obj_res, "m_iNumControlPoints", control_point_count-1);

    // set all the other CPs to visible
    for (local i = 0; i < control_point_count-1; i++) {
        NetProps.SetPropBoolArray(obj_res, "m_bCPIsVisible", true, i);
    }

    // make the fake CP invisible
    NetProps.SetPropBoolArray(obj_res, "m_bCPIsVisible", false, control_point_count-1);

}

// swaps the HUD from payload to control points.
function SwapHud() {
    NetProps.SetPropInt(tf_gamerules, "m_nHudType", 2);

    // disables the train watcher (prevents spectating the cart)
    team_train_watcher.AcceptInput("Disable", "", null, null);

    // set all the other CPs to invisible
    for (local i = 0; i < control_point_count-1; i++) {
        NetProps.SetPropBoolArray(obj_res, "m_bCPIsVisible", false, i);
    }

    // make the fake CP visible
    NetProps.SetPropBoolArray(obj_res, "m_bCPIsVisible", true, control_point_count-1);

    // make sure the fake CP shows in the HUD now
    NetProps.SetPropInt(obj_res, "m_iNumControlPoints", control_point_count);
}